/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mike Lee's code.
 *
 * The Initial Developer of the Original Code is
 * Mike Lee.
 * Portions created by the Initial Developer are Copyright (C) 2002
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *	Mike Lee <tseng_mike@yahoo.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
//var mgPrefBI = mgPref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);

var recentResult = null;
var recentPublish = false;

var xmlRpcClient;
var xmlRpc = getXmlRpc();
var serverurl;
var blogAppkey;
var blogid;
var username;
var password;

var tempPostID; // postid for checking permlink

function initBlog()
{
  var blogNS = "http://www.exitspace.net/blog/";
  var MozBlogLocalStr = document.getElementById("bundle_MozBlog");

  serverurl  = xmlRpc.createType(xmlRpc.STRING, {});
  blogAppkey = xmlRpc.createType(xmlRpc.STRING, {});
  blogid     = xmlRpc.createType(xmlRpc.STRING, {});
  username   = xmlRpc.createType(xmlRpc.STRING, {});
  password   = xmlRpc.createType(xmlRpc.STRING, {});

  try {
	var ds                 = rdfStore.getSource("profile");
	var RDFContainer       = Components.classes["@mozilla.org/rdf/container;1"]
                                 .getService(Components.interfaces.nsIRDFContainer);
    var RDF   	           = Components.classes['@mozilla.org/rdf/rdf-service;1']
					             .getService(Components.interfaces.nsIRDFService);

    var blogPingBlogNS	   = RDF.GetResource(blogNS + "pingBlog");
    var blogRetrieveNumNS  = RDF.GetResource(blogNS + "retrieveNum");
    var BlogSrvNS 		   = RDF.GetResource(blogNS + "blogServer");
    var SiteIDNS 		   = RDF.GetResource(blogNS + "siteID");

    var currentBlogID      = document.getElementById("blogIDs").selectedItem.value;
    var blogIDNS           = RDF.GetResource(currentBlogID);
    var BlogSrvContainerNS = ds.GetTarget(blogIDNS, BlogSrvNS, true)
                               .QueryInterface(Components.interfaces.nsIRDFResource);

    serverurl.data         = getRDFAttribute(ds, BlogSrvContainerNS, blogNS+"serverUrl");
    blogAppkey.data        = getRDFAttribute(ds, BlogSrvContainerNS, blogNS+"appKey");
	username.data          = getRDFAttribute(ds, BlogSrvContainerNS, blogNS+"username");
    blogid.data            = getRDFAttribute(ds, blogIDNS, blogNS + "siteID");
    var tmpPassword        = loadPassword(getRDFAttribute(ds, BlogSrvContainerNS, blogNS+"serverUrl"),
  								          getRDFAttribute(ds, BlogSrvContainerNS, blogNS+"username"));
    password.data          = tmpPassword;
	ds = null;
  } catch (e) {
	alert (MozBlogLocalStr.getString("MozBlog.ErrorSP") + e);
  }
}

function getClient() {
  return Components.classes["@mozilla.org/xml-rpc/client;1"]
                   .createInstance(Components.interfaces.nsIXmlRpcClient);
}

function getXmlRpc() {
  if (!xmlRpcClient) xmlRpcClient = getClient();
  return xmlRpcClient;
}

/**
 * getUserInfo return the blog user's information
 * returns a dictionary with userid, firstname, lastname, nickname, email, and url
 */
function getUserInfo()
{
  initBlog();
  xmlRpc.init(serverurl);
  xmlRpc.asyncCall(Listener, null, "blogger.getUserInfo", [blogAppkey, blogid, username, password], 4);
}

/**
 * getUserInfo return the user's blog(s) information
 * returns an array of dictionary with blogid, blogname, and url
 */
function getUserBlog()
{
  initBlog();
  xmlRpc.init(serverurl);
  xmlRpc.asyncCall(blogInfoListener, null, "blogger.getUsersBlogs", [blogAppkey, username, password], 3);
}

var blogInfoListener = {
  onResult: function(client, ctxt, result) {
    var blogList = document.getElementById("blogIDs");
    var blogInfoResult = result.QueryInterface(Components.interfaces.nsISupportsArray);
    for (i = 0; i < blogInfoResult.Count(); i++) {
      dictResult = blogInfoResult.QueryElementAt(i, Components.interfaces.nsIDictionary);
      try {
        dictResult1 = dictResult.getValue("blogName")
                                .QueryInterface(Components.interfaces.nsISupportsString);
        dictResult2 = dictResult.getValue("blogid")
                                .QueryInterface(Components.interfaces.nsISupportsString);
      } catch (e) {
        dictResult1 = dictResult.getValue("blogName")
                                .QueryInterface(Components.interfaces.nsISupportsCString);
        dictResult2 = dictResult.getValue("blogid")
                                .QueryInterface(Components.interfaces.nsISupportsCString);
      }
      blogList.insertItemAt(i + 1, dictResult1.data, dictResult2.data);
    }
    statusReport("Index loaded");
  }, onFault: function(client, ctxt, fault) {
    dump("Fault! " + fault + "\n");
  }, onError: function(client, ctxt, status, errorMsg) {
    dump("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
  }
};

var httpRequest;

function loadSite(currentSiteUrl)
{
  httpRequest    = new XMLHttpRequest()
  httpRequest.onload = XMLlistener;
  httpRequest.overrideMimeType("text/xml");
  httpRequest.open("GET", currentSiteUrl);
  httpRequest.send(null);
}

function XMLlistener(e)
{
  var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  var permLink = document.getElementById("blogIDs").selectedItem.value;
  if (httpRequest.responseText) {
    currentSiteContent = httpRequest.responseText;
    var regex = new RegExp("\href=[\"']?(.+)" + tempPostID, "gi");
    regex.exec(currentSiteContent);
    var urlPath = RegExp.$1;
    var siteUrl = permLink;
    if (urlPath) {
      regex = new RegExp(siteUrl, "gi");
      if (!regex.test(urlPath)) {
        if (siteUrl.charAt(siteUrl.length-1) != '/')
          if (urlPath.charAt(0) != '/') siteUrl = siteUrl + '/';
      } else siteUrl = "";
      permLink = siteUrl + urlPath + tempPostID;
      postStore.permLink = permLink;
      editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.Done"), 100);  //
    } else {
     editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.PostID") + tempPostID + MozBlogLocalStr.getString("MozBlog.NotFoundInContent"), 100);
    }
  } else {
    editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.PageContentNA"), 100);
  }
  postStore.published = "Y";
  postStore.saveToDisk();
  var blogTitle       = document.getElementById("doctitle").value;
  var blogDescription = document.getElementById("docDescription").value;
  postRSSData(permLink, blogTitle, blogDescription);
  editorHandle.viewHtml();
  updateSelection();
  pingbackBlog(permLink);
}

var httpPost;

function postRSSData(permlink, title, description)
{
  var blogID = document.getElementById("blogIDs").selectedItem.value;
  if (permlink == blogID)
    permlink = permlink + "#" + tempPostID;
  httpPost    = new XMLHttpRequest();
  httpPost.onload = rssResult;
  httpPost.open("POST", "http://www.exitspace.net/utils/rssdatasource.php");
  httpPost.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  var blogName = document.getElementById("blogIDs").selectedItem.getAttribute("label");
  var postStr;
  try {
    postStr = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
  } catch (e) {
    postStr = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsCString);
  }
  postStr = "siteName=" + escape(blogName) + "&siteUrl=" + escape(blogID) + "&permlink=" + escape(permlink);
  postStr += "&title=" + escape(title) + "&description=" + escape(description);
  httpPost.send(postStr);
}

function rssResult(e)
{
  var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  dump (httpPost.responseText);
  editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.RSSGenerated"), 100);
}

/**
 * newPost post a new entry to blogger
 * returns the unique postId assigned
 */
function bloggerNewPost(postContent, postPublish)
{
  initBlog();
  var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.MakingNewPosts"), null);
  editorHandle.viewStatus();
  var content = xmlRpc.createType(xmlRpc.STRING, {});
  content.data = postContent;
  var publish = xmlRpc.createType(xmlRpc.BOOLEAN, {});
  publish.data = postPublish;
  xmlRpc.init(serverurl);
  xmlRpc.asyncCall(newPostListener, null, "blogger.newPost",
                   [blogAppkey, blogid, username, password, content, publish], 6);
}

var newPostListener = {
  //var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  onResult: function(client, ctxt, result) {
    var currentblogID = document.getElementById("blogIDs").selectedItem.value;
    result     = result.QueryInterface(Components.interfaces.nsISupportsPrimitive);
    if (result.type == 3 || result.type == 2) {
      var blogStatus;
      try {
        blogStatus = result.QueryInterface(Components.interfaces.nsISupportsString);
      } catch (e) {
        blogStatus = result.QueryInterface(Components.interfaces.nsISupportsCString);
      }
      postStore.postID = blogStatus.data;
      tempPostID = blogStatus.data;
      if (getAccountType() == "blogger") {
        editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Done"), 100);
        editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Checking") + globalState.blogID + "...");
        var interval = window.setTimeout("loadSite(globalState.blogID)", 3000);
      } else {
        postStore.published = "Y";
        postStore.saveToDisk();
        editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Done"), 100);
        editorHandle.viewHtml();
        updateSelection();
      }
      var newInterval = window.setTimeout("pingbackBlog(globalState.blogID)", 500);
    } else {
      editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.BlogServerRetUnexpctVal") + result.type + "\n");
    }
  }, onFault: function(client, ctxt, fault) {
    editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Fault") + fault + "\n");
  }, onError: function(client, ctxt, status, errorMsg) {
    editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Error") + status.toString(16) + ") " + errorMsg + "\n");
  }
};

/**
 * editPost edit an existing post
 * return boolean
 */
function bloggerEditPost(postID, postContent, postPublish)
{
  initBlog();
  var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.EditPosts") + postID + "...", null);
  editorHandle.viewStatus();
  var postId = xmlRpc.createType(xmlRpc.STRING, {});
  postId.data = postID;
  var content = xmlRpc.createType(xmlRpc.STRING, {});
  content.data = postContent;
  var publish = xmlRpc.createType(xmlRpc.BOOLEAN, {});
  publish.data = postPublish;
  xmlRpc.init(serverurl);
  xmlRpc.asyncCall(editPostListener, null, "blogger.editPost",
                   [blogAppkey, postId, username, password, content, publish], 6);
}

var editPostListener = {
  //var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  onResult: function(client, ctxt, result) {
    var blogID = document.getElementById("blogIDs").selectedItem.value;
    result = result.QueryInterface(Components.interfaces.nsISupportsPrimitive);
    if (result.type == 4) {
      var blogStatus = result.QueryInterface(Components.interfaces.nsISupportsPRBool);
      blogStatus = blogStatus.data;
      postStore.published = "Y";
      postStore.saveToDisk();
      editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Done"), 100);
      editorHandle.viewHtml();
      updateSelection();
      var interval = window.setTimeout("pingbackBlog(blogID)", 500);
    } else {
      editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.BlogServerRetUnexpctVal") + result.type + "\n", 100);
      updateSelection();
    }
  }, onFault: function(client, ctxt, fault) {
    editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Fault") + fault + "\n");
  }, onError: function(client, ctxt, status, errorMsg) {
    editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Error") + status.toString(16) + ") " + errorMsg + "\n");
  }
};


/**
 * getPost get an post's informatiom
 * return a dictionary of userid, postid, content, and dateCreated
 */
function bloggerGetPost(postID)
{
  initBlog();
  var postId = xmlRpc.createType(xmlRpc.STRING, {});
  postId.data = postID;
  xmlRpc.init(serverurl);
  xmlRpc.asyncCall(Listener, null, "blogger.getPost", [blogAppkey, postId, username, password], 4);
}

/**
 * deletePost delete an existing post
 * return boolean
 */
function bloggerDeletePost(postID)
{
  initBlog();
  var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.DeletePost") + postID + "...", null);
  editorHandle.viewStatus();
  var postId = xmlRpc.createType(xmlRpc.STRING, {});
  postId.data = postID;
  var publish = xmlRpc.createType(xmlRpc.BOOLEAN, {});
  publish.data = false;
  xmlRpc.init(serverurl);
  xmlRpc.asyncCall(deletePostListener, null, "blogger.deletePost",
                   [blogAppkey, postId, username, password, publish], 5);
}

var deletePostListener = {
  //var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  onResult: function(client, ctxt, result) {
    result = result.QueryInterface(Components.interfaces.nsISupportsPrimitive);
    if (result.type == 4) {
      var blogStatus = result.QueryInterface(Components.interfaces.nsISupportsPRBool);
      postListBox.deleteSelection();
      blogStatus = blogStatus.data;
      editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Done"), 100);
      editorHandle.viewHtml();
      clearField();
      updateSelection();
    } else {
      editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.BlogServerRetUnexpctVal") + result.type);
    }
  }, onFault: function(client, ctxt, fault) {
    editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Fault") + fault + "\n");
  }, onError: function(client, ctxt, status, errorMsg) {
    editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Error") + status.toString(16) + ") " + errorMsg + "\n", 100);
  }
};

/**
 * getRecentPost get an array of recent post (<20)
 * return an array of dictionary with postid, content, userid, dateCreated
 */
function bloggerGetRecentPosts(numPost)
{
  initBlog();
  var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  //getFormattedString("MozBlog.Get", [IntNumPost]), null);
  editorHandle.currentStatus(MozBlogLocalStr.getString("MozBlog.Get") + " " + numPost + " " + MozBlogLocalStr.getString("MozBlog.RecentPosts"), null);
  editorHandle.viewStatus();
  var postNum = xmlRpc.createType(xmlRpc.INT, {});
  postNum.data = numPost;
  xmlRpc.init(serverurl);
  xmlRpc.asyncCall(recentPostListener, null, "blogger.getRecentPosts",
	  			  [blogAppkey, blogid, username, password, postNum], 5);
}


var recentPostListener = {
  //var MozBlogLocalStr = document.getElementById("bundle_MozBlog");
  onResult: function(client, ctxt, result) {
    recentResult = result.QueryInterface(Components.interfaces.nsISupportsArray);
    dump ("its started\n");
    for (i = 0; i < recentResult.Count(); i++) {
      dictResult = recentResult.QueryElementAt(i, Components.interfaces.nsIDictionary);
      dictResult1 = dictResult.getValue("dateCreated")
                              .QueryInterface(Components.interfaces.nsISupportsPRTime);
      try {
        dictResult2 = dictResult.getValue("postid")
                                .QueryInterface(Components.interfaces.nsISupportsString);
        blogContent = dictResult.getValue("content")
                                .QueryInterface(Components.interfaces.nsISupportsString);
      } catch (e) {
        dictResult2 = dictResult.getValue("postid")
                                .QueryInterface(Components.interfaces.nsISupportsCString);
        blogContent = dictResult.getValue("content")
                                .QueryInterface(Components.interfaces.nsISupportsCString);
      }
      dump ("before: ");
      postStore.content     = blogContent;
      postStore.postID      = dictResult2;
      postStore.blogID      = document.getElementById("blogIDs").selectedItem.value;
      postStore.date        = getISO8601Date(dictResult1.data);
      postStore.filename    = dictResult1.data + ".html";
      postStore.title       = null;
      postStore.description = null;
      postStore.category    = null;
      postStore.permLink    = null;
      postStore.published   = "Y";
      dump (dictResult2+"\n");
      postStore.saveToDisk();
      dump ("finish1\n");
    }
    editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.PostsImported"), 100);
    dump ("its done\n");
    updateSelection();
    dump ("its finished\n");
  }, onFault: function(client, ctxt, fault) {
    editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Fault") + fault + "\n");
  }, onError: function(client, ctxt, status, errorMsg) {
    editorHandle.currentStatus(document.getElementById("bundle_MozBlog").getString("MozBlog.Error") + status.toString(16) + ") " + errorMsg + "\n", 100);
    
    //editorHandle.currentStatus('\n\nResponseXML:\n'+xmlRpc.responseText+'\n', 100);
  }
};